// Util.cpp: implementation of the CUtil class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#if defined(WIN32)
#include "Util.h"
#include "shlobj.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUtil::CUtil()
{

}

CUtil::~CUtil()
{

}

/********************************************************************************
    return ʹ ο new char[]  ޸ ̴. ݵ ؾ.
 *********************************************************************************/
char * CUtil::ReadFile(LPCSTR szFilename, DWORD & dwTotalRead)
{
	HANDLE hFile; 
	
	hFile = ::CreateFile(szFilename,           // open MYFILE.TXT 
		GENERIC_READ,              // open for reading 
		FILE_SHARE_READ | FILE_SHARE_WRITE,           // share for reading 
		NULL,                      // no security 
		OPEN_EXISTING,             // existing file only 
		FILE_ATTRIBUTE_NORMAL,     // normal file 
		NULL);                     // no attr. template 
	
	if (hFile == INVALID_HANDLE_VALUE) 
	{ 
		return NULL;
	}

	DWORD dwFileSize = ::GetFileSize( hFile, NULL );
	if (dwFileSize == INVALID_FILE_SIZE)
	{
		CloseHandle( hFile );
		return NULL;
	}

	DWORD dwBytesRead = 0;
	dwTotalRead = 0;
	char * pReadData = new char[dwFileSize + 1];
	if (NULL == pReadData)
	{
		CloseHandle( hFile );
		delete [] pReadData;
		return NULL;
	}
	
	while (dwTotalRead < dwFileSize)
	{ 
		if (!::ReadFile(hFile, pReadData + dwTotalRead, dwFileSize - dwTotalRead, &dwBytesRead, NULL)) 
		{
			CloseHandle( hFile );
			delete [] pReadData;
			return NULL;
		}
		
		dwTotalRead += dwBytesRead;
	}
	pReadData[dwTotalRead] = 0;
	
	::CloseHandle( hFile );
	
	return pReadData;
}

/********************************************************************************
    Data  File  .  truncate ..
 *********************************************************************************/
bool CUtil::WriteFile(LPCSTR szFilename, LPCSTR szData, DWORD dwDataLen)
{
	HANDLE hFile; 
	
	hFile = ::CreateFile(szFilename,           // open MYFILE.TXT 
		GENERIC_WRITE,              // open for reading 
		0,							// not permit share
		NULL,                      // no security 
		CREATE_ALWAYS,             // 
		FILE_ATTRIBUTE_NORMAL,     // normal file 
		NULL);                     // no attr. template 
	
	if (hFile == INVALID_HANDLE_VALUE)
		return false;

	DWORD dwWritten = 0;
	DWORD dwNumberOfBytesWritten;
	while( dwWritten < dwDataLen )
	{
		if( FALSE == ::WriteFile(hFile, szData+dwWritten, dwDataLen - dwWritten, &dwNumberOfBytesWritten, NULL) )
		{
			break;
		}
		dwWritten += dwNumberOfBytesWritten;
	}
	
	::CloseHandle( hFile );

	return dwWritten == dwDataLen;
}

bool CUtil::VerifyDirectory(LPCSTR szDir)
{
	DWORD dwFA = GetFileAttributes( szDir );
	if( 0xffffffff == dwFA )
	{
		const char * pEnd = strrchr( szDir, '\\' );

		if( pEnd == NULL )
			return false;

		int len = pEnd - szDir;

		char szSubDir[MAX_PATH+1];
		strncpy(szSubDir, szDir, len);
		szSubDir[len] = '\0';

		if( !VerifyDirectory( szSubDir ) )
			return false;

		if( !CreateDirectory( szDir, 0 ) )
			return false;

		return true;
	}
	else if( FILE_ATTRIBUTE_DIRECTORY & dwFA )
		return true;

	return false;
}

int CUtil::ReadRegistry(LPCTSTR szCompany, LPCTSTR szAppName, LPCTSTR szSection, LPCTSTR szDataName, void * pDataValue, int nMaxSize, DWORD * pdwType)
{
	TCHAR KeyStr[256];
	HKEY hRegKey = NULL;

	_stprintf(KeyStr, _T("Software\\%s\\%s\\%s"), szCompany, szAppName, szSection);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return 0;

	if(RegQueryValueEx(hRegKey, szDataName, 0, pdwType, (LPBYTE)pDataValue, (LPDWORD)&nMaxSize) != ERROR_SUCCESS)
		nMaxSize = 0;
	RegCloseKey(hRegKey);
	
	return nMaxSize;
}

BOOL CUtil::WriteRegistry(LPCTSTR szCompany, LPCTSTR szAppName, LPCTSTR szSection, LPCTSTR szDataName, const void * pDataValue, int nSize, DWORD dwType)
{
	TCHAR KeyStr[256];
	HKEY hRegKey = NULL;

	_stprintf(KeyStr, _T("Software\\%s\\%s\\%s"), szCompany, szAppName, szSection);

	DWORD dwDisposition;
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_WRITE, NULL, &hRegKey, &dwDisposition) != ERROR_SUCCESS)
		return FALSE;

	RegSetValueEx(hRegKey, szDataName, 0, dwType, (LPBYTE)pDataValue, nSize);
	RegCloseKey(hRegKey);

	return TRUE;
}

typedef HRESULT (WINAPI * SHGetFolderPathProc)(
    HWND hwndOwner,
    int nFolder,
    HANDLE hToken,
    DWORD dwFlags,
    LPTSTR pszPath
);

HRESULT CUtil::NP_SHGetFolderPath(HWND hwndOwner, int nFolder, HANDLE hToken, DWORD dwFlags, LPTSTR pszPath)
{
	_tcscpy(pszPath, _T(""));
	HRESULT hResult;

#ifndef _UNICODE
	hResult = E_FAIL;
#else
	hResult = S_FALSE;
#endif

	HMODULE hModule = LoadLibrary(_T("SHFolder.dll"));
	SHGetFolderPathProc SHGetFolderPath = NULL;
	if(hModule)
	{
#ifndef _UNICODE
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathA");
#else
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathW");
#endif
		if(SHGetFolderPath)
		{
			hResult = SHGetFolderPath(NULL, CSIDL_LOCAL_APPDATA, NULL, 0, pszPath);
			if(hResult != 0)
			{
				GetWindowsDirectory(pszPath, MAX_PATH);
				_tcscat(pszPath, _T("\\Local Settings\\Application Data"));
				hResult = 0;
			}
		}
	}
	if(hModule)
		FreeLibrary(hModule);

	return hResult;
}


void CUtil::RetailOutput(LPCTSTR szFormat, ...)
{
    TCHAR szBuffer[1024];  // Large buffer for long filenames or URLs	

    const size_t NUMCHARS = sizeof(szBuffer) / sizeof(szBuffer[0]);
    const int LASTCHAR = NUMCHARS - 1;
	
    // Format the input string
    va_list pArgs;
    va_start(pArgs, szFormat);

    // Use a bounded buffer size to prevent buffer overruns.  Limit count to
    // character size minus one to allow for a NULL terminating character.
    _vsntprintf(szBuffer, NUMCHARS - 1, szFormat, pArgs);
    va_end(pArgs);

    // Ensure that the formatted string is NULL-terminated
    szBuffer[LASTCHAR] = _T('\0');
	DWORD dwWritten;
	TCHAR filename[MAX_PATH];
	SYSTEMTIME tm;
	GetLocalTime(&tm);

	_stprintf(filename, _T("C:\\NPMSGR_%04d%02d%02d.log"), tm.wYear, tm.wMonth, tm.wDay );
	_stprintf( szBuffer, _T("%s [%02d:%02d:%02d]"), szBuffer, tm.wHour, tm.wMinute, tm.wSecond);	
	_tcscat(szBuffer, _T("\r\n"));

	HANDLE hFile = CreateFile(filename, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	DWORD dwPoint = SetFilePointer(hFile, 0, 0, FILE_END);	

#ifdef _UNICODE
	BYTE data[2];
	data[0] = 0xFF;
	data[1] = 0xFE;
	if (!dwPoint)
	{
		WriteFile(hFile,  data, 2, &dwWritten, 0);
	}
#endif

	::WriteFile(hFile, szBuffer, _tcslen(szBuffer)*sizeof(TCHAR), &dwWritten, 0);
	CloseHandle(hFile);

    OutputDebugString(szBuffer);
}

#endif